#ifndef __3c905c_h
#define __3c905c_h 1

#define C905C_MAJOR 121
#define PCI_N_REGS 6
#define PCI_DEVICE_ID_3COM_905C 0x9200
#define PCI_VENDOR_ID_3COM 0x10b7

struct PCI_Region {
    int busy;
    unsigned int phy_addr;
    unsigned int log_addr;
    unsigned int size;
};

struct PCI_Device {
    int found;
    unsigned short cmd;
    unsigned short stat;
    unsigned char rev;
    int regs;
    struct PCI_Region reg[PCI_N_REGS];
};

struct C905C_NIC {
    union {
	struct window0 {
	    volatile u_int reserved0;
	    volatile u_int BiosRomAddr;
	    volatile u_char BiosFormData;
	    volatile u_char reserved1;
	    volatile u_short EepromCommand;
	    volatile u_short EepromData;
	    volatile u_short IntStatus;
	}w0;

	struct window1 {
	    volatile u_char SmbFifoData;
	    volatile u_char SmbAddress;
	    volatile u_short SmbStatus;
	    volatile u_char SmbArb;
	    volatile u_char SmbDialog;
	    volatile u_short SmbRxBytes;
	    volatile u_short WakeOnTimer;
	    volatile u_char SosBits;
	    volatile u_char reserved;
	    volatile u_short TriggerBits;
	    volatile u_short IntStatus;
	}w1;

	struct window2 {
	    volatile u_short StationAddressLo;
	    volatile u_short StationAddressMid;
	    volatile u_short StationAddressHi;
	    volatile u_short StationMaskLo;
	    volatile u_short StationMaskMid;
	    volatile u_short StationMaskHi;
	    volatile u_short ResetOptions;
	    volatile u_short IntStatus;
	}w2;

	struct window3 {
	    volatile u_int InternalConfig;
	    volatile u_short MaxPktSize;
	    volatile u_short MacControl;
	    volatile u_short MediaOptions;
	    volatile u_short RxFree;
	    volatile u_short TxFree;
	    volatile u_short IntStatus;
	}w3;

	struct window4 {
	    volatile u_short reserved0;
	    volatile u_short VcoDiagnostic;
	    volatile u_short FifoDiagnostic;
	    volatile u_short NetworkDiagnostic;
	    volatile u_short PhysicalMgmt;
	    volatile u_short MediaStatus;
	    volatile u_char BadSSD;
	    volatile u_char UpperBytesOK;
	    volatile u_short IntStatus;
	}w4;

	struct window5 {
	    volatile u_short TxStartThresh;
	    volatile u_short reserved0;
	    volatile u_short reserved1;
	    volatile u_short RxEarlyThresh;
	    volatile u_char RxFilter;
	    volatile u_char TxReclaimThresh;
	    volatile u_short InterruptEnable;
	    volatile u_short IndicationEnable;
	    volatile u_short IntStatus;
	}w5;

	struct window6 {
	    volatile u_char CarrierLost;
	    volatile u_char SqeErrors;
	    volatile u_char MultipleCollisions;
	    volatile u_char SingleCollisions;
	    volatile u_char LateCollisions;
	    volatile u_char RxOverruns;
	    volatile u_char FramesXmittedOk;
	    volatile u_char FramesRcvdOk;
	    volatile u_char FramesDeferred;
	    volatile u_char UpperFramesOk;
	    volatile u_short BytesRcvdOk;
	    volatile u_short BytesXmittdOk;
	    volatile u_short IntStatus;
	}w6;

	struct window7 {
	    volatile u_short VlanMask;
	    volatile u_short reserved0;
	    volatile u_short VlanEtherType;
	    volatile u_short reserved1;
	    volatile u_int reserved2;
	    volatile u_short PowerMgmtEvent;
	    volatile u_short IntStatus;
	}w7;

    } win;

    volatile u_int          reserved0;
    volatile u_int          reserved1;
    volatile u_char         txpktid;
    volatile u_char         reserved2;
    volatile u_char         timer;
    volatile u_char         txstatus;
    volatile u_short        reserved3;
    volatile u_short        shortstatusauto;
    volatile u_int          DmaCtrl;
    volatile u_int          DnListPtr;
    volatile u_short        reserved4;
    volatile u_char         DnBurst_Thresh;
    volatile u_char         reserved5;
    volatile u_char         Dpriority_Thresh;
    volatile u_char         DnPoll;
    volatile u_short        reserved6;
    volatile u_int          UpPktStatus;
    volatile u_short        FreeTimer;
    volatile u_short        Countdown;
    volatile u_int          UpListPtr;
    volatile u_char         UpPriority;
    volatile u_char         UpPoll;
    volatile u_char         UpBurstThresh;
    volatile u_char         reserved7;
    volatile u_int          RealTimeCnt;
    volatile u_char         ConfigAddress;
    volatile u_char         reserved8;
    volatile u_char         reserved9;
    volatile u_char         reserved10;
    volatile u_char         ConfigData;
    volatile u_char         reserved11;
    volatile u_char         reserved12;
    volatile u_char         reserved13;
    volatile u_int          reserved14;
    volatile u_int          reserved15;
    volatile u_int          reserved16;
    volatile u_int          reserved17;
    volatile u_int          reserved18;
    volatile u_int          reserved19;
    volatile u_int          reserved20;
    volatile u_int          reserved21;
    volatile u_int          reserved22;
    volatile u_int          DebugData;
    volatile u_short        DebugControl;
    volatile u_short        reserved23;
    volatile u_short        DnMaxBurst;
    volatile u_short        UpMaxBurst;
    volatile u_short        PowerMgmtCtrl;
    volatile u_short        reserved24;
};

struct Header {
    u_char dst[6];
    u_char src[6];
    u_short type;
};

struct Frame {
    struct Header header;
    unsigned char payload[1500];
};

struct DPD {
    volatile struct DPD *DnNextPtr;
    volatile u_int FrameStartHeader;
    volatile u_int DnFragAddress;
    volatile u_int DnFragLen;
};

struct UPD {
    volatile struct DPD *UpNextPtr;
    volatile u_int UpPktStatus;
    volatile u_int UpFragAddress;
    volatile u_int UpFragLen;
};

#endif

